/**
* Module:  Tutorial code for the XK-1
* Version: 0.1
* File:    main.xc
*
* The copyrights, all other intellectual and industrial
* property rights are retained by XMOS and/or its licensors.
* Terms and conditions covering the use of this code can
* be found in the Xmos End User License Agreement.
*
* Copyright XMOS Ltd 2009
**/


#include <xs1.h>

#define FLASH_PERIOD 10000000 //100 ms
#define CYCLE_PERIOD 50000000 //500 ms

out port led = XS1_PORT_4F;

int main (void) {
	unsigned ledOn = 1;
	unsigned ledVal = 1;
	timer tmrF , tmrC ;
	unsigned timeF , timeC ;
	
	tmrF :> timeF;
	tmrC :> timeC;

	while (1) {
		select {
		case tmrF when timerafter ( timeF ) :> void :
			ledOn = ! ledOn ;
			if (ledOn) led <: ledVal;
			else led <: 0;
			timeF += FLASH_PERIOD ;
		break ;
		
		case tmrC when timerafter ( timeC ) :> void :
			ledVal <<= 1;
			if ( ledVal == 0x10 )
			ledVal = 1;
			timeC += CYCLE_PERIOD ;
		break ;
		}
	}
	return 0;
}
